package implement

import (
	"code.fnuoos.com/EggPlanet/egg_models.git/src/dao"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	zhios_order_relate_logx "code.fnuoos.com/EggPlanet/egg_models.git/utils/logx"
	"xorm.io/xorm"
)

func NewEggEnergyCommunityDividendsDb(engine *xorm.Engine) dao.EggEnergyCommunityDividendsDao {
	return &EggEnergyCommunityDividendsDb{Db: engine}
}

type EggEnergyCommunityDividendsDb struct {
	Db *xorm.Engine
}

func (e EggEnergyCommunityDividendsDb) EggEnergyCommunityDividendsFindAndCount(page, limit int, startAt, endAt string, startNums, endNums int64) ([]*model.EggEnergyCommunityDividends, int64, error) {
	var m []*model.EggEnergyCommunityDividends
	session := e.Db.Where("")
	if startAt != "" {
		session = session.And("create_at > ?", startAt)
	}
	if endAt != "" {
		session = session.And("create_at < ?", endAt)
	}
	if startNums != 0 {
		session = session.And("nums > ?", startNums)
	}
	if endNums != 0 {
		session = session.And("nums < ?", endNums)
	}
	total, err := session.Limit(limit, (page-1)*limit).FindAndCount(&m)
	if err != nil {
		return nil, 0, zhios_order_relate_logx.Error(err.Error())
	}
	return m, total, nil
}

func (e EggEnergyCommunityDividendsDb) EggEnergyCommunityDividendsInsert(EggEnergyCommunityDividends *model.EggEnergyCommunityDividends) (int, error) {
	_, err := e.Db.InsertOne(EggEnergyCommunityDividends)
	if err != nil {
		return 0, err
	}
	return EggEnergyCommunityDividends.Id, nil
}
